This is a "plugin" for the Video Disk Recorder (VDR).

Written by:                          Hardy Flor <HFlor@web.de>

Project's homepage (autotimeredit):  www.fast-info.de/vdr/autotimeredit

See the file COPYING for license information.

autotimeredit-plugin version 0.1.8

This is a plugin for the Video Disk Recorder (VDR) to edit the vdradmind.at
for vdradmind via VDR on-screen-display (OSD).

spezial handling:

- the entry in the mainmenu kann set unseeable by command line parameter 'hide_in_mainmenu' or from setup-menu
- in the autotimerlist you can edit a entry with key 1 .. 0 (10) directly
- if a command line parameter are set and in the setup-menu 'Preferr Command Line Parameter' is 'yes' then is the option not shown
- for select a default dictionary by edit a autotimer use the key 'blue' to switch between the input or select

- for select a weekday to search with vdradmin-am >=3.4.1 use the key 1..7 (Monday..Sonnday) or left/right to select defined days

config parameter:

- adjustable in setings/plugin/autotimeredit
- command line (see below)
- file 'autotimeredit.conf' (or name in '@' command line option) in <config-dir>/plugins (same syntax as command line)
  in this config file comment with '#' are allowed

command line parameters:

  -f path      --autotimerfile=path           Select Autotimer-file (same for vdradmind!)
               --nosetup_autotimerfile        Hide the file from setup-menu
               --ns_autotimerfile             same as --nosetup_autotimerfile
  -p           --use_sighup_vdradmin          Use SIGHUP (vdradmind >=0.96 or patch) for update Autotimer
  -x           --use_sighup_xxv               Use SIGHUP (xxv) for update Autotimer
               --nosetup_update_method        Hide the use_sgihup from setup-menu
               --ns_update_method             same as --nosetup_use_sighup
  -u path      --vdradminupdate=path          Script/Config-file for force update autotimer
               --nosetup_vdradminupdate       Hide the vdradminupdate-file form setup-menu
               --ns_vdradminupdate            same as --nosetup_vdradminupdate
  -m           --visible_in_mainmenu          Show the plugin in the mainmenu
  -M           --hide_in_mainmenu             Hide the plugin in the mainmenu
  -n Name      --mainmenu_name=Name           Select Name for entry in the mainmenu (set also -m)
  -v           --verbose                      Enable more logging
  -V           --noverbose                    Disable more loggig;
  -r           --use_repeat_feature           use the repeat feature from vdradmin bigpatch 0.9
  -R           --not_use_repeat_feature       not use, it set automatic to use, if the autotimerfile with 11 values
               --nosetup_repeat_feature       Hide the option from setup-menu
               --ns_repeat_feature            same as --nosetup_repeat_feature
* -k           --use_weekday_feature          use the repeat feature from vdradmin am 3.4.1, sets also -r
* -K           --not_use_weekday_feature      not use, it set automatic to use, if the autotimerfile with 12 values
*              --nosetup_weekday_feature      Hide the option from setup-menu
*              --ns_weekday_feature           same as --nosetup_weekday_feature
  -b           --update_begin                 Show the manual update line at begin of autotimer-list
  -B           --noupdate_begin               Hide the manual update line at begin of autotimer-list
  -e           --update_end                   Show the manual update line at end of autotimer-list
  -E           --noupdate_end                 Hide the manual update line at end of autotimer-list
  -q           --question_update              When one or more Autotimer are modifed, by quit the plugin appears a question for force search update
  -Q           --noquestion_update            see above but no question
  -l           --show_flags                   For the Autotimerlist show search in title, subtitle and description as a single char
  -L           --hide_flags                   column is hide
  -a           --show_start                   For the Autotimerlist show the startsearchtime
  -A           --hide_start                   column is hide
  -t           --show_stop                    For the Autotimerlist show the stopsearchtime
  -T           --hide_stop                    column is hide
  -c           --show_channel                 For the Autotimerlist show the searchchannel
  -C           --hide_channel                 column is hide
  -s           --show_channel_name            if show_channel the name of channel is use
  -S           --show_channel_number          if show_channel the number of channel is use
               --nosetup_commandline          Hide the Preferr Command Line Parameter form setup-menu
               --ns_commandline               same as --nosetup_commandline
  -d dir[,dir] --defaultdictionary=dir[,dir]  set the default choise for the dictionary (space '_', any special char with #xx) a dictionary for blacklist starts with '~' include subdictionary with '~~'
  -D bitset    --use_defaultdictionary=bitset Select the source for the defaultdictionary 0x01 - autotimer 0x02 - timer 0x04 - records 0x08 - commandline 0x10 - setup
               --nosetup_defaultdictionary    Hide all options with default dictionary from setup-menu
               --ns_defaultdictionary         same as nosetup_defaultdictionary
  -y time      --updatetimerecords=time       time (hours) between two updates for defaultdictionary from records (-1 only by start, 0 by each call autotimeredit)
               --nosetup_updatetimerecords    Hide the updatetimerecords option from setup-menu
               --ns_updatetimerecords         same as nosetup_updatetimerecords
   @file                                      file for read more options (relativ to <config-dir>/plugins, or when begins with '/' absolute)

* new options in 1.7

version 1.3 allowed the expand of environmentvariables in the parameters '--autotimerfile' and '--vdradminupdate' with the format $MYPATH/... or ${MYPATH}/...
multiple '//' are chaned to one '/'

The option 'vdradminupdate=path' or 'use_sighup_?' is used for the manual update (force new search) of autotimer.

1. If the specified file is executable, it will run with parameter 'restart'.
For instance you can specify there vdradmin´s start script /etc/init.d/vdradmin.
This start script stops and restarts the vdradmind and thereby it starts a new autotimersearch.

2. If it isn´t an executable file, it is the configuration file of vdradmind (/etc/vdradmin/vdradmind.conf).
Then this file is searched for parameters for user, password and port.
After that 'wget http://user:password@localhost:port/vdradmin.pl?aktion=force_update' is called.
Note, that the program 'wget' should be installed.

3. For use_sighup_vdradmin is a new version of vdradmind required (>=0.96) or a patch for 0.95. The plugin search the pip of
vdradmind.pl and send a sighup for update the autotimer.

4. use_sighup_xxv, The plugin search the pip of xxv.pl and send a sighup for update the autotimer.

For option 1., 3. or 4. is vdradmind/xxv runing on the same machine required.
For option 2. is only a config-file with the parameter

PASSWORD = xxx
SERVERHOST = a.b.c.d
SERVERPORT = 8000
USERNAME = linvdr

for a vdradmin on a remote machine required.

***************************************************************************************************************************

Wenn die angegebene Datei ausführbar ist, so wird sie mit dem Parameter 'restart' aufgerufen.
z.B. könnte hier das Startscript von vdradmin (/etc/init.d/vdradmin) angegeben werden.
Mit diesem Startscript wird der vdradmind entladen und neu gestartet und dadurch werden die Autotimer-Einträge neu gesucht.

Wenn es keine ausführbare Datei ist, handelt es sich um die Konfigurationsdatei von vdradmind (/etc/vdradmin/vdradmind.conf).
Diese Datei wird dann nach den Parametern für User, Passwort und Port durchsucht.
Anschließend wird 'wget http://user:passwort@localhost:port/vdradmin.pl?aktion=force_update' aufgerufen.
Dazu muß natürlich das Programm 'wget' installiert sein.

